
import javassist.*;

public class Example3 {

	public static void main (String[] args) throws Exception {
		ClassPool pool = ClassPool.getDefault();

		// the class name is 'Eval'
		CtClass evalClass = pool.makeClass("Eval"+System.currentTimeMillis());
			// Since we don't really care about the class name, we'll append the
			// current milliseconds as a minimal guard against multi-threading problems

		// the interface implemented by the new class
		evalClass.setInterfaces(
			new CtClass[] { pool.makeClass("Evaluator") });

		// add fields with a few constants
		evalClass.addField(
			CtField.make("private double pi = Math.PI;", evalClass));
		evalClass.addField(
			CtField.make("private java.util.Random rnd;", evalClass));

		// add constructor for initializing the Random object
		CtConstructor constr = CtNewConstructor.defaultConstructor(evalClass);
		constr.setBody("{ rnd = new java.util.Random(System.currentTimeMillis()); }");
		evalClass.addConstructor(constr);

		// add 'rnd' method for random numbers
		evalClass.addMethod(CtNewMethod.make("public double rnd() { return rnd.nextDouble(); }", evalClass));

		// add the eval method to the class
		evalClass.addMethod(
			CtNewMethod.make("public double eval (double x) { return ("+args[0]+") ; }", evalClass));

		// get a java.lang.Class object from Javassist's CtClass object
		Class clazz = evalClass.toClass();

		// instantiate it and cast it to Evaluator
		Evaluator obj  = (Evaluator) clazz.newInstance();

		// and finally call the method
		double result = obj.eval(Double.parseDouble(args[1]));
		System.out.println(result);
	}
}

